import { expect } from 'chai';
import { getSortedLayoutIndexes } from '../src/rules2/src/table/getSortedLayoutIndexes';

describe('getSortedLayoutIndexes tests', () => {
  it('basic case', () => {
    const layout = {
      header: [{ id: 'd1', __index: 0 }],
      sections: [{ id: 'd2', __index: 1 }],
      rows: [{ id: 'd3', __index: 2 }],
    };
    const observations = {
      '0:0:0': { orderedDimIndexes: [0, 0, 0] },
      '0:0:1': { orderedDimIndexes: [0, 0, 1] },
      '0:1:0': { orderedDimIndexes: [0, 1, 0] },
      '0:1:1': { orderedDimIndexes: [0, 1, 1] },
      '1:0:0': { orderedDimIndexes: [1, 0, 0] },
      '1:0:1': { orderedDimIndexes: [1, 0, 1] },
      '1:1:0': { orderedDimIndexes: [1, 1, 0] },
      '1:1:1': { orderedDimIndexes: [1, 1, 1] },
    };

    const layoutIndexes = {
      header: [[0], [1]],
      sections: [
        [[0], [[0], [1]]],
        [[1], [[0], [1]]]
      ]
    };

    expect(getSortedLayoutIndexes(layout, observations)).to.deep.equal(layoutIndexes);    
  });
  it('mixed order dimensions test', () => {
    const layout = {
      header: [
        { id: 'd3', __index: 2 },
        { id: 'd1', __index: 0 }
      ],
      sections: [],
      rows: [{ id: 'd2', __index: 1 }],
    };

    const layoutIndexes = {
      header: [[0, 0], [0, 1], [0, 2], [1, 0], [1, 1], [1, 2], [2, 0], [2, 1], [2, 2]],
      sections: [[[], [[0], [1], [2]]]]
    };

    const observations = {
      '0:0:0': { orderedDimIndexes: [0, 0, 0] },
      '0:0:1': { orderedDimIndexes: [0, 0, 1] },
      '0:0:2': { orderedDimIndexes: [0, 0, 2] },
      '0:1:0': { orderedDimIndexes: [0, 1, 0] },
      '0:1:1': { orderedDimIndexes: [0, 1, 1] },
      '0:1:2': { orderedDimIndexes: [0, 1, 2] },
      '0:2:0': { orderedDimIndexes: [0, 2, 0] },
      '0:2:1': { orderedDimIndexes: [0, 2, 1] },
      '0:2:2': { orderedDimIndexes: [0, 2, 2] },
      '1:0:0': { orderedDimIndexes: [1, 0, 0] },
      '1:0:1': { orderedDimIndexes: [1, 0, 1] },
      '1:0:2': { orderedDimIndexes: [1, 0, 2] },
      '1:1:0': { orderedDimIndexes: [1, 1, 0] },
      '1:1:1': { orderedDimIndexes: [1, 1, 1] },
      '1:1:2': { orderedDimIndexes: [1, 1, 2] },
      '1:2:0': { orderedDimIndexes: [1, 2, 0] },
      '1:2:1': { orderedDimIndexes: [1, 2, 1] },
      '1:2:2': { orderedDimIndexes: [1, 2, 2] },
      '2:0:0': { orderedDimIndexes: [2, 0, 0] },
      '2:0:1': { orderedDimIndexes: [2, 0, 1] },
      '2:0:2': { orderedDimIndexes: [2, 0, 2] },
      '2:1:0': { orderedDimIndexes: [2, 1, 0] },
      '2:1:1': { orderedDimIndexes: [2, 1, 1] },
      '2:1:2': { orderedDimIndexes: [2, 1, 2] },
      '2:2:0': { orderedDimIndexes: [2, 2, 0] },
      '2:2:1': { orderedDimIndexes: [2, 2, 1] },
      '2:2:2': { orderedDimIndexes: [2, 2, 2] },
    };

    expect(getSortedLayoutIndexes(layout, observations)).to.deep.equal(layoutIndexes);    
  });
  it('combination in layout', () => {
    const layout = {
      header: [{ id: 'd1', __index: 0 }],
      sections: [{ id: 'd2', __index: 1 }],
      rows: [{ id: 'd3', __index: 2 }, { id: 'COMB', dimensions: [{ id: 'd4', __index: 3 }, { id: 'd5', __index: 4 }] }],
    };

    const observations = {
      '0:0:0:0:0': { orderedDimIndexes: [0, 0, 0, 0, 0] },
      '0:0:0:0:1': { orderedDimIndexes: [0, 0, 0, 0, 1] },
      '0:0:0:0:2': { orderedDimIndexes: [0, 0, 0, 0, 2] },
      '0:0:0:1:0': { orderedDimIndexes: [0, 0, 0, 1, 0] },
      '0:0:0:1:1': { orderedDimIndexes: [0, 0, 0, 1, 1] },
      '0:0:0:1:2': { orderedDimIndexes: [0, 0, 0, 1, 2] },
      '0:0:0:2:0': { orderedDimIndexes: [0, 0, 0, 2, 0] },
      '0:0:0:2:1': { orderedDimIndexes: [0, 0, 0, 2, 1] },
      '0:0:0:2:2': { orderedDimIndexes: [0, 0, 0, 2, 2] },
      '0:0:1:0:0': { orderedDimIndexes: [0, 0, 1, 0, 0] },
      '0:0:1:0:1': { orderedDimIndexes: [0, 0, 1, 0, 1] },
      '0:0:1:0:2': { orderedDimIndexes: [0, 0, 1, 0, 2] },
      '0:0:1:1:0': { orderedDimIndexes: [0, 0, 1, 1, 0] },
      '0:0:1:1:1': { orderedDimIndexes: [0, 0, 1, 1, 1] },
      '0:0:1:1:2': { orderedDimIndexes: [0, 0, 1, 1, 2] },
      '0:0:1:2:0': { orderedDimIndexes: [0, 0, 1, 2, 0] },
      '0:0:1:2:1': { orderedDimIndexes: [0, 0, 1, 2, 1] },
      '0:0:1:2:2': { orderedDimIndexes: [0, 0, 1, 2, 2] },
      '0:0:2:0:0': { orderedDimIndexes: [0, 0, 2, 0, 0] },
      '0:0:2:0:1': { orderedDimIndexes: [0, 0, 2, 0, 1] },
      '0:0:2:0:2': { orderedDimIndexes: [0, 0, 2, 0, 2] },
      '0:0:2:1:0': { orderedDimIndexes: [0, 0, 2, 1, 0] },
      '0:0:2:1:1': { orderedDimIndexes: [0, 0, 2, 1, 1] },
      '0:0:2:1:2': { orderedDimIndexes: [0, 0, 2, 1, 2] },
      '0:0:2:2:0': { orderedDimIndexes: [0, 0, 2, 2, 0] },
      '0:0:2:2:1': { orderedDimIndexes: [0, 0, 2, 2, 1] },
      '0:0:2:2:2': { orderedDimIndexes: [0, 0, 2, 2, 2] },
      '0:1:0:0:0': { orderedDimIndexes: [0, 1, 0, 0, 0] },
      '0:1:0:0:1': { orderedDimIndexes: [0, 1, 0, 0, 1] },
      '0:1:0:0:2': { orderedDimIndexes: [0, 1, 0, 0, 2] },
      '0:1:0:1:0': { orderedDimIndexes: [0, 1, 0, 1, 0] },
      '0:1:0:1:1': { orderedDimIndexes: [0, 1, 0, 1, 1] },
      '0:1:0:1:2': { orderedDimIndexes: [0, 1, 0, 1, 2] },
      '0:1:0:2:0': { orderedDimIndexes: [0, 1, 0, 2, 0] },
      '0:1:0:2:1': { orderedDimIndexes: [0, 1, 0, 2, 1] },
      '0:1:0:2:2': { orderedDimIndexes: [0, 1, 0, 2, 2] },
      '0:1:1:0:0': { orderedDimIndexes: [0, 1, 1, 0, 0] },
      '0:1:1:0:1': { orderedDimIndexes: [0, 1, 1, 0, 1] },
      '0:1:1:0:2': { orderedDimIndexes: [0, 1, 1, 0, 2] },
      '0:1:1:1:0': { orderedDimIndexes: [0, 1, 1, 1, 0] },
      '0:1:1:1:1': { orderedDimIndexes: [0, 1, 1, 1, 1] },
      '0:1:1:1:2': { orderedDimIndexes: [0, 1, 1, 1, 2] },
      '0:1:1:2:0': { orderedDimIndexes: [0, 1, 1, 2, 0] },
      '0:1:1:2:1': { orderedDimIndexes: [0, 1, 1, 2, 1] },
      '0:1:1:2:2': { orderedDimIndexes: [0, 1, 1, 2, 2] },
      '0:1:2:0:0': { orderedDimIndexes: [0, 1, 2, 0, 0] },
      '0:1:2:0:1': { orderedDimIndexes: [0, 1, 2, 0, 1] },
      '0:1:2:0:2': { orderedDimIndexes: [0, 1, 2, 0, 2] },
      '0:1:2:1:0': { orderedDimIndexes: [0, 1, 2, 1, 0] },
      '0:1:2:1:1': { orderedDimIndexes: [0, 1, 2, 1, 1] },
      '0:1:2:1:2': { orderedDimIndexes: [0, 1, 2, 1, 2] },
      '0:1:2:2:0': { orderedDimIndexes: [0, 1, 2, 2, 0] },
      '0:1:2:2:1': { orderedDimIndexes: [0, 1, 2, 2, 1] },
      '0:1:2:2:2': { orderedDimIndexes: [0, 1, 2, 2, 2] },
      '1:0:0:0:0': { orderedDimIndexes: [1, 0, 0, 0, 0] },
      '1:0:0:0:1': { orderedDimIndexes: [1, 0, 0, 0, 1] },
      '1:0:0:0:2': { orderedDimIndexes: [1, 0, 0, 0, 2] },
      '1:0:0:1:0': { orderedDimIndexes: [1, 0, 0, 1, 0] },
      '1:0:0:1:1': { orderedDimIndexes: [1, 0, 0, 1, 1] },
      '1:0:0:1:2': { orderedDimIndexes: [1, 0, 0, 1, 2] },
      '1:0:0:2:0': { orderedDimIndexes: [1, 0, 0, 2, 0] },
      '1:0:0:2:1': { orderedDimIndexes: [1, 0, 0, 2, 1] },
      '1:0:0:2:2': { orderedDimIndexes: [1, 0, 0, 2, 2] },
      '1:0:1:0:0': { orderedDimIndexes: [1, 0, 1, 0, 0] },
      '1:0:1:0:1': { orderedDimIndexes: [1, 0, 1, 0, 1] },
      '1:0:1:0:2': { orderedDimIndexes: [1, 0, 1, 0, 2] },
      '1:0:1:1:0': { orderedDimIndexes: [1, 0, 1, 1, 0] },
      '1:0:1:1:1': { orderedDimIndexes: [1, 0, 1, 1, 1] },
      '1:0:1:1:2': { orderedDimIndexes: [1, 0, 1, 1, 2] },
      '1:0:1:2:0': { orderedDimIndexes: [1, 0, 1, 2, 0] },
      '1:0:1:2:1': { orderedDimIndexes: [1, 0, 1, 2, 1] },
      '1:0:1:2:2': { orderedDimIndexes: [1, 0, 1, 2, 2] },
      '1:0:2:0:0': { orderedDimIndexes: [1, 0, 2, 0, 0] },
      '1:0:2:0:1': { orderedDimIndexes: [1, 0, 2, 0, 1] },
      '1:0:2:0:2': { orderedDimIndexes: [1, 0, 2, 0, 2] },
      '1:0:2:1:0': { orderedDimIndexes: [1, 0, 2, 1, 0] },
      '1:0:2:1:1': { orderedDimIndexes: [1, 0, 2, 1, 1] },
      '1:0:2:1:2': { orderedDimIndexes: [1, 0, 2, 1, 2] },
      '1:0:2:2:0': { orderedDimIndexes: [1, 0, 2, 2, 0] },
      '1:0:2:2:1': { orderedDimIndexes: [1, 0, 2, 2, 1] },
      '1:0:2:2:2': { orderedDimIndexes: [1, 0, 2, 2, 2] },
      '1:1:0:0:0': { orderedDimIndexes: [1, 1, 0, 0, 0] },
      '1:1:0:0:1': { orderedDimIndexes: [1, 1, 0, 0, 1] },
      '1:1:0:0:2': { orderedDimIndexes: [1, 1, 0, 0, 2] },
      '1:1:0:1:0': { orderedDimIndexes: [1, 1, 0, 1, 0] },
      '1:1:0:1:1': { orderedDimIndexes: [1, 1, 0, 1, 1] },
      '1:1:0:1:2': { orderedDimIndexes: [1, 1, 0, 1, 2] },
      '1:1:0:2:0': { orderedDimIndexes: [1, 1, 0, 2, 0] },
      '1:1:0:2:1': { orderedDimIndexes: [1, 1, 0, 2, 1] },
      '1:1:0:2:2': { orderedDimIndexes: [1, 1, 0, 2, 2] },
      '1:1:1:0:0': { orderedDimIndexes: [1, 1, 1, 0, 0] },
      '1:1:1:0:1': { orderedDimIndexes: [1, 1, 1, 0, 1] },
      '1:1:1:0:2': { orderedDimIndexes: [1, 1, 1, 0, 2] },
      '1:1:1:1:0': { orderedDimIndexes: [1, 1, 1, 1, 0] },
      '1:1:1:1:1': { orderedDimIndexes: [1, 1, 1, 1, 1] },
      '1:1:1:1:2': { orderedDimIndexes: [1, 1, 1, 1, 2] },
      '1:1:1:2:0': { orderedDimIndexes: [1, 1, 1, 2, 0] },
      '1:1:1:2:1': { orderedDimIndexes: [1, 1, 1, 2, 1] },
      '1:1:1:2:2': { orderedDimIndexes: [1, 1, 1, 2, 2] },
      '1:1:2:0:0': { orderedDimIndexes: [1, 1, 2, 0, 0] },
      '1:1:2:0:1': { orderedDimIndexes: [1, 1, 2, 0, 1] },
      '1:1:2:0:2': { orderedDimIndexes: [1, 1, 2, 0, 2] },
      '1:1:2:1:0': { orderedDimIndexes: [1, 1, 2, 1, 0] },
      '1:1:2:1:1': { orderedDimIndexes: [1, 1, 2, 1, 1] },
      '1:1:2:1:2': { orderedDimIndexes: [1, 1, 2, 1, 2] },
      '1:1:2:2:0': { orderedDimIndexes: [1, 1, 2, 2, 0] },
      '1:1:2:2:1': { orderedDimIndexes: [1, 1, 2, 2, 1] },
      '1:1:2:2:2': { orderedDimIndexes: [1, 1, 2, 2, 2] },
    };

    const expected = {
      header: [[0], [1]],
      sections: [
        [
          [0],
          [
            [0, [0, 0]],
            [0, [0, 1]],
            [0, [0, 2]],
            [0, [1, 0]],
            [0, [1, 1]],
            [0, [1, 2]],
            [0, [2, 0]],
            [0, [2, 1]],
            [0, [2, 2]],
            [1, [0, 0]],
            [1, [0, 1]],
            [1, [0, 2]],
            [1, [1, 0]],
            [1, [1, 1]],
            [1, [1, 2]],
            [1, [2, 0]],
            [1, [2, 1]],
            [1, [2, 2]],
            [2, [0, 0]],
            [2, [0, 1]],
            [2, [0, 2]],
            [2, [1, 0]],
            [2, [1, 1]],
            [2, [1, 2]],
            [2, [2, 0]],
            [2, [2, 1]],
            [2, [2, 2]],
          ]
        ],
        [
          [1],
          [
            [0, [0, 0]],
            [0, [0, 1]],
            [0, [0, 2]],
            [0, [1, 0]],
            [0, [1, 1]],
            [0, [1, 2]],
            [0, [2, 0]],
            [0, [2, 1]],
            [0, [2, 2]],
            [1, [0, 0]],
            [1, [0, 1]],
            [1, [0, 2]],
            [1, [1, 0]],
            [1, [1, 1]],
            [1, [1, 2]],
            [1, [2, 0]],
            [1, [2, 1]],
            [1, [2, 2]],
            [2, [0, 0]],
            [2, [0, 1]],
            [2, [0, 2]],
            [2, [1, 0]],
            [2, [1, 1]],
            [2, [1, 2]],
            [2, [2, 0]],
            [2, [2, 1]],
            [2, [2, 2]],
          ]
        ]
      ]
    };

    expect(getSortedLayoutIndexes(layout, observations)).to.deep.equal(expected);  
  });
  it('multi combinations in layout', () => {
    const layout = {
      header: [{ id: 'COMB1', dimensions: [{ id: 'd0', __index: 0 }, { id: 'd1', __index: 1 }] }],
      sections: [],
      rows: [
        { id: 'COMB2', dimensions: [{ id: 'd2', __index: 2 }, { id: 'd3', __index: 3 }] },
        { id: 'COMB3', dimensions: [{ id: 'd4', __index: 4 }, { id: 'd5', __index: 5 }] },
      ]
    };

    const observations = {
      '0:0:0:0:0:0': { orderedDimIndexes: [0, 0, 0, 0, 0, 0] },
      '0:0:0:0:0:1': { orderedDimIndexes: [0, 0, 0, 0, 0, 1] },
      '0:0:0:0:0:2': { orderedDimIndexes: [0, 0, 0, 0, 0, 2] },
      '0:0:0:0:1:0': { orderedDimIndexes: [0, 0, 0, 0, 1, 0] },
      '0:0:0:0:1:1': { orderedDimIndexes: [0, 0, 0, 0, 1, 1] },
      '0:0:0:0:1:2': { orderedDimIndexes: [0, 0, 0, 0, 1, 2] },
      '0:0:0:0:2:0': { orderedDimIndexes: [0, 0, 0, 0, 2, 0] },
      '0:0:0:0:2:1': { orderedDimIndexes: [0, 0, 0, 0, 2, 1] },
      '0:0:0:0:2:2': { orderedDimIndexes: [0, 0, 0, 0, 2, 2] },
      '0:0:0:1:0:0': { orderedDimIndexes: [0, 0, 0, 1, 0, 0] },
      '0:0:0:1:0:1': { orderedDimIndexes: [0, 0, 0, 1, 0, 1] },
      '0:0:0:1:0:2': { orderedDimIndexes: [0, 0, 0, 1, 0, 2] },
      '0:0:0:1:1:0': { orderedDimIndexes: [0, 0, 0, 1, 1, 0] },
      '0:0:0:1:1:1': { orderedDimIndexes: [0, 0, 0, 1, 1, 1] },
      '0:0:0:1:1:2': { orderedDimIndexes: [0, 0, 0, 1, 1, 2] },
      '0:0:0:1:2:0': { orderedDimIndexes: [0, 0, 0, 1, 2, 0] },
      '0:0:0:1:2:1': { orderedDimIndexes: [0, 0, 0, 1, 2, 1] },
      '0:0:0:1:2:2': { orderedDimIndexes: [0, 0, 0, 1, 2, 2] },
      '0:0:0:2:0:0': { orderedDimIndexes: [0, 0, 0, 2, 0, 0] },
      '0:0:0:2:0:1': { orderedDimIndexes: [0, 0, 0, 2, 0, 1] },
      '0:0:0:2:0:2': { orderedDimIndexes: [0, 0, 0, 2, 0, 2] },
      '0:0:0:2:1:0': { orderedDimIndexes: [0, 0, 0, 2, 1, 0] },
      '0:0:0:2:1:1': { orderedDimIndexes: [0, 0, 0, 2, 1, 1] },
      '0:0:0:2:1:2': { orderedDimIndexes: [0, 0, 0, 2, 1, 2] },
      '0:0:0:2:2:0': { orderedDimIndexes: [0, 0, 0, 2, 2, 0] },
      '0:0:0:2:2:1': { orderedDimIndexes: [0, 0, 0, 2, 2, 1] },
      '0:0:0:2:2:2': { orderedDimIndexes: [0, 0, 0, 2, 2, 2] },
      '0:0:1:0:0:0': { orderedDimIndexes: [0, 0, 1, 0, 0, 0] },
      '0:0:1:0:0:1': { orderedDimIndexes: [0, 0, 1, 0, 0, 1] },
      '0:0:1:0:0:2': { orderedDimIndexes: [0, 0, 1, 0, 0, 2] },
      '0:0:1:0:1:0': { orderedDimIndexes: [0, 0, 1, 0, 1, 0] },
      '0:0:1:0:1:1': { orderedDimIndexes: [0, 0, 1, 0, 1, 1] },
      '0:0:1:0:1:2': { orderedDimIndexes: [0, 0, 1, 0, 1, 2] },
      '0:0:1:0:2:0': { orderedDimIndexes: [0, 0, 1, 0, 2, 0] },
      '0:0:1:0:2:1': { orderedDimIndexes: [0, 0, 1, 0, 2, 1] },
      '0:0:1:0:2:2': { orderedDimIndexes: [0, 0, 1, 0, 2, 2] },
      '0:0:1:1:0:0': { orderedDimIndexes: [0, 0, 1, 1, 0, 0] },
      '0:0:1:1:0:1': { orderedDimIndexes: [0, 0, 1, 1, 0, 1] },
      '0:0:1:1:0:2': { orderedDimIndexes: [0, 0, 1, 1, 0, 2] },
      '0:0:1:1:1:0': { orderedDimIndexes: [0, 0, 1, 1, 1, 0] },
      '0:0:1:1:1:1': { orderedDimIndexes: [0, 0, 1, 1, 1, 1] },
      '0:0:1:1:1:2': { orderedDimIndexes: [0, 0, 1, 1, 1, 2] },
      '0:0:1:1:2:0': { orderedDimIndexes: [0, 0, 1, 1, 2, 0] },
      '0:0:1:1:2:1': { orderedDimIndexes: [0, 0, 1, 1, 2, 1] },
      '0:0:1:1:2:2': { orderedDimIndexes: [0, 0, 1, 1, 2, 2] },
      '0:0:1:2:0:0': { orderedDimIndexes: [0, 0, 1, 2, 0, 0] },
      '0:0:1:2:0:1': { orderedDimIndexes: [0, 0, 1, 2, 0, 1] },
      '0:0:1:2:0:2': { orderedDimIndexes: [0, 0, 1, 2, 0, 2] },
      '0:0:1:2:1:0': { orderedDimIndexes: [0, 0, 1, 2, 1, 0] },
      '0:0:1:2:1:1': { orderedDimIndexes: [0, 0, 1, 2, 1, 1] },
      '0:0:1:2:2:0': { orderedDimIndexes: [0, 0, 1, 2, 2, 0] },
      '0:0:1:2:2:1': { orderedDimIndexes: [0, 0, 1, 2, 2, 1] },
      '0:0:1:2:2:2': { orderedDimIndexes: [0, 0, 1, 2, 2, 2] },
      '0:0:2:0:0:0': { orderedDimIndexes: [0, 0, 2, 0, 0, 0] },
      '0:0:2:0:0:1': { orderedDimIndexes: [0, 0, 2, 0, 0, 1] },
      '0:0:2:0:0:2': { orderedDimIndexes: [0, 0, 2, 0, 0, 2] },
      '0:0:2:0:1:0': { orderedDimIndexes: [0, 0, 2, 0, 1, 0] },
      '0:0:2:0:1:1': { orderedDimIndexes: [0, 0, 2, 0, 1, 1] },
      '0:0:2:0:1:2': { orderedDimIndexes: [0, 0, 2, 0, 1, 2] },
      '0:0:2:0:2:0': { orderedDimIndexes: [0, 0, 2, 0, 2, 0] },
      '0:0:2:0:2:1': { orderedDimIndexes: [0, 0, 2, 0, 2, 1] },
      '0:0:2:0:2:2': { orderedDimIndexes: [0, 0, 2, 0, 2, 2] },
      '0:0:2:1:0:0': { orderedDimIndexes: [0, 0, 2, 1, 0, 0] },
      '0:0:2:1:0:1': { orderedDimIndexes: [0, 0, 2, 1, 0, 1] },
      '0:0:2:1:0:2': { orderedDimIndexes: [0, 0, 2, 1, 0, 2] },
      '0:0:2:1:1:0': { orderedDimIndexes: [0, 0, 2, 1, 1, 0] },
      '0:0:2:1:1:1': { orderedDimIndexes: [0, 0, 2, 1, 1, 1] },
      '0:0:2:1:1:2': { orderedDimIndexes: [0, 0, 2, 1, 1, 2] },
      '0:0:2:1:2:0': { orderedDimIndexes: [0, 0, 2, 1, 2, 0] },
      '0:0:2:1:2:1': { orderedDimIndexes: [0, 0, 2, 1, 2, 1] },
      '0:0:2:1:2:2': { orderedDimIndexes: [0, 0, 2, 1, 2, 2] },
      '0:0:2:2:0:0': { orderedDimIndexes: [0, 0, 2, 2, 0, 0] },
      '0:0:2:2:0:1': { orderedDimIndexes: [0, 0, 2, 2, 0, 1] },
      '0:0:2:2:0:2': { orderedDimIndexes: [0, 0, 2, 2, 0, 2] },
      '0:0:2:2:1:0': { orderedDimIndexes: [0, 0, 2, 2, 1, 0] },
      '0:0:2:2:1:1': { orderedDimIndexes: [0, 0, 2, 2, 1, 1] },
      '0:0:2:2:1:2': { orderedDimIndexes: [0, 0, 2, 2, 1, 2] },
      '0:0:2:2:2:0': { orderedDimIndexes: [0, 0, 2, 2, 2, 0] },
      '0:0:2:2:2:1': { orderedDimIndexes: [0, 0, 2, 2, 2, 1] },
      '0:0:2:2:2:2': { orderedDimIndexes: [0, 0, 2, 2, 2, 2] },
      '0:1:0:0:0:0': { orderedDimIndexes: [0, 1, 0, 0, 0, 0] },
      '0:1:0:0:0:1': { orderedDimIndexes: [0, 1, 0, 0, 0, 1] },
      '0:1:0:0:0:2': { orderedDimIndexes: [0, 1, 0, 0, 0, 2] },
      '0:1:0:0:1:0': { orderedDimIndexes: [0, 1, 0, 0, 1, 0] },
      '0:1:0:0:1:1': { orderedDimIndexes: [0, 1, 0, 0, 1, 1] },
      '0:1:0:0:1:2': { orderedDimIndexes: [0, 1, 0, 0, 1, 2] },
      '0:1:0:0:2:0': { orderedDimIndexes: [0, 1, 0, 0, 2, 0] },
      '0:1:0:0:2:1': { orderedDimIndexes: [0, 1, 0, 0, 2, 1] },
      '0:1:0:0:2:2': { orderedDimIndexes: [0, 1, 0, 0, 2, 2] },
      '0:1:0:1:0:0': { orderedDimIndexes: [0, 1, 0, 1, 0, 0] },
      '0:1:0:1:0:1': { orderedDimIndexes: [0, 1, 0, 1, 0, 1] },
      '0:1:0:1:0:2': { orderedDimIndexes: [0, 1, 0, 1, 0, 2] },
      '0:1:0:1:1:0': { orderedDimIndexes: [0, 1, 0, 1, 1, 0] },
      '0:1:0:1:1:1': { orderedDimIndexes: [0, 1, 0, 1, 1, 1] },
      '0:1:0:1:1:2': { orderedDimIndexes: [0, 1, 0, 1, 1, 2] },
      '0:1:0:1:2:0': { orderedDimIndexes: [0, 1, 0, 1, 2, 0] },
      '0:1:0:1:2:1': { orderedDimIndexes: [0, 1, 0, 1, 2, 1] },
      '0:1:0:1:2:2': { orderedDimIndexes: [0, 1, 0, 1, 2, 2] },
      '0:1:0:2:0:0': { orderedDimIndexes: [0, 1, 0, 2, 0, 0] },
      '0:1:0:2:0:1': { orderedDimIndexes: [0, 1, 0, 2, 0, 1] },
      '0:1:0:2:0:2': { orderedDimIndexes: [0, 1, 0, 2, 0, 2] },
      '0:1:0:2:1:0': { orderedDimIndexes: [0, 1, 0, 2, 1, 0] },
      '0:1:0:2:1:1': { orderedDimIndexes: [0, 1, 0, 2, 1, 1] },
      '0:1:0:2:1:2': { orderedDimIndexes: [0, 1, 0, 2, 1, 2] },
      '0:1:0:2:2:0': { orderedDimIndexes: [0, 1, 0, 2, 2, 0] },
      '0:1:0:2:2:1': { orderedDimIndexes: [0, 1, 0, 2, 2, 1] },
      '0:1:0:2:2:2': { orderedDimIndexes: [0, 1, 0, 2, 2, 2] },
      '0:1:1:0:0:0': { orderedDimIndexes: [0, 1, 1, 0, 0, 0] },
      '0:1:1:0:0:1': { orderedDimIndexes: [0, 1, 1, 0, 0, 1] },
      '0:1:1:0:0:2': { orderedDimIndexes: [0, 1, 1, 0, 0, 2] },
      '0:1:1:0:1:0': { orderedDimIndexes: [0, 1, 1, 0, 1, 0] },
      '0:1:1:0:1:1': { orderedDimIndexes: [0, 1, 1, 0, 1, 1] },
      '0:1:1:0:1:2': { orderedDimIndexes: [0, 1, 1, 0, 1, 2] },
      '0:1:1:0:2:0': { orderedDimIndexes: [0, 1, 1, 0, 2, 0] },
      '0:1:1:0:2:1': { orderedDimIndexes: [0, 1, 1, 0, 2, 1] },
      '0:1:1:0:2:2': { orderedDimIndexes: [0, 1, 1, 0, 2, 2] },
      '0:1:1:1:0:0': { orderedDimIndexes: [0, 1, 1, 1, 0, 0] },
      '0:1:1:1:0:1': { orderedDimIndexes: [0, 1, 1, 1, 0, 1] },
      '0:1:1:1:0:2': { orderedDimIndexes: [0, 1, 1, 1, 0, 2] },
      '0:1:1:1:1:0': { orderedDimIndexes: [0, 1, 1, 1, 1, 0] },
      '0:1:1:1:1:1': { orderedDimIndexes: [0, 1, 1, 1, 1, 1] },
      '0:1:1:1:1:2': { orderedDimIndexes: [0, 1, 1, 1, 1, 2] },
      '0:1:1:1:2:0': { orderedDimIndexes: [0, 1, 1, 1, 2, 0] },
      '0:1:1:1:2:1': { orderedDimIndexes: [0, 1, 1, 1, 2, 1] },
      '0:1:1:1:2:2': { orderedDimIndexes: [0, 1, 1, 1, 2, 2] },
      '0:1:1:2:0:0': { orderedDimIndexes: [0, 1, 1, 2, 0, 0] },
      '0:1:1:2:0:1': { orderedDimIndexes: [0, 1, 1, 2, 0, 1] },
      '0:1:1:2:0:2': { orderedDimIndexes: [0, 1, 1, 2, 0, 2] },
      '0:1:1:2:1:0': { orderedDimIndexes: [0, 1, 1, 2, 1, 0] },
      '0:1:1:2:1:1': { orderedDimIndexes: [0, 1, 1, 2, 1, 1] },
      '0:1:1:2:1:2': { orderedDimIndexes: [0, 1, 1, 2, 1, 2] },
      '0:1:1:2:2:0': { orderedDimIndexes: [0, 1, 1, 2, 2, 0] },
      '0:1:1:2:2:1': { orderedDimIndexes: [0, 1, 1, 2, 2, 1] },
      '0:1:1:2:2:2': { orderedDimIndexes: [0, 1, 1, 2, 2, 2] },
      '0:1:2:0:0:0': { orderedDimIndexes: [0, 1, 2, 0, 0, 0] },
      '0:1:2:0:0:1': { orderedDimIndexes: [0, 1, 2, 0, 0, 1] },
      '0:1:2:0:0:2': { orderedDimIndexes: [0, 1, 2, 0, 0, 2] },
      '0:1:2:0:1:0': { orderedDimIndexes: [0, 1, 2, 0, 1, 0] },
      '0:1:2:0:1:1': { orderedDimIndexes: [0, 1, 2, 0, 1, 1] },
      '0:1:2:0:1:2': { orderedDimIndexes: [0, 1, 2, 0, 1, 2] },
      '0:1:2:0:2:0': { orderedDimIndexes: [0, 1, 2, 0, 2, 0] },
      '0:1:2:0:2:1': { orderedDimIndexes: [0, 1, 2, 0, 2, 1] },
      '0:1:2:0:2:2': { orderedDimIndexes: [0, 1, 2, 0, 2, 2] },
      '0:1:2:1:0:0': { orderedDimIndexes: [0, 1, 2, 1, 0, 0] },
      '0:1:2:1:0:1': { orderedDimIndexes: [0, 1, 2, 1, 0, 1] },
      '0:1:2:1:0:2': { orderedDimIndexes: [0, 1, 2, 1, 0, 2] },
      '0:1:2:1:1:0': { orderedDimIndexes: [0, 1, 2, 1, 1, 0] },
      '0:1:2:1:1:1': { orderedDimIndexes: [0, 1, 2, 1, 1, 1] },
      '0:1:2:1:1:2': { orderedDimIndexes: [0, 1, 2, 1, 1, 2] },
      '0:1:2:1:2:0': { orderedDimIndexes: [0, 1, 2, 1, 2, 0] },
      '0:1:2:1:2:1': { orderedDimIndexes: [0, 1, 2, 1, 2, 1] },
      '0:1:2:1:2:2': { orderedDimIndexes: [0, 1, 2, 1, 2, 2] },
      '0:1:2:2:0:0': { orderedDimIndexes: [0, 1, 2, 2, 0, 0] },
      '0:1:2:2:0:1': { orderedDimIndexes: [0, 1, 2, 2, 0, 1] },
      '0:1:2:2:0:2': { orderedDimIndexes: [0, 1, 2, 2, 0, 2] },
      '0:1:2:2:1:0': { orderedDimIndexes: [0, 1, 2, 2, 1, 0] },
      '0:1:2:2:1:1': { orderedDimIndexes: [0, 1, 2, 2, 1, 1] },
      '0:1:2:2:1:2': { orderedDimIndexes: [0, 1, 2, 2, 1, 2] },
      '0:1:2:2:2:0': { orderedDimIndexes: [0, 1, 2, 2, 2, 0] },
      '0:1:2:2:2:1': { orderedDimIndexes: [0, 1, 2, 2, 2, 1] },
      '0:1:2:2:2:2': { orderedDimIndexes: [0, 1, 2, 2, 2, 2] },
      '0:2:0:0:0:0': { orderedDimIndexes: [0, 2, 0, 0, 0, 0] },
      '0:2:0:0:0:1': { orderedDimIndexes: [0, 2, 0, 0, 0, 1] },
      '0:2:0:0:0:2': { orderedDimIndexes: [0, 2, 0, 0, 0, 2] },
      '0:2:0:0:1:0': { orderedDimIndexes: [0, 2, 0, 0, 1, 0] },
      '0:2:0:0:1:1': { orderedDimIndexes: [0, 2, 0, 0, 1, 1] },
      '0:2:0:0:1:2': { orderedDimIndexes: [0, 2, 0, 0, 1, 2] },
      '0:2:0:0:2:0': { orderedDimIndexes: [0, 2, 0, 0, 2, 0] },
      '0:2:0:0:2:1': { orderedDimIndexes: [0, 2, 0, 0, 2, 1] },
      '0:2:0:0:2:2': { orderedDimIndexes: [0, 2, 0, 0, 2, 2] },
      '0:2:0:1:0:0': { orderedDimIndexes: [0, 2, 0, 1, 0, 0] },
      '0:2:0:1:0:1': { orderedDimIndexes: [0, 2, 0, 1, 0, 1] },
      '0:2:0:1:0:2': { orderedDimIndexes: [0, 2, 0, 1, 0, 2] },
      '0:2:0:1:1:0': { orderedDimIndexes: [0, 2, 0, 1, 1, 0] },
      '0:2:0:1:1:1': { orderedDimIndexes: [0, 2, 0, 1, 1, 1] },
      '0:2:0:1:1:2': { orderedDimIndexes: [0, 2, 0, 1, 1, 2] },
      '0:2:0:1:2:0': { orderedDimIndexes: [0, 2, 0, 1, 2, 0] },
      '0:2:0:1:2:1': { orderedDimIndexes: [0, 2, 0, 1, 2, 1] },
      '0:2:0:1:2:2': { orderedDimIndexes: [0, 2, 0, 1, 2, 2] },
      '0:2:0:2:0:0': { orderedDimIndexes: [0, 2, 0, 2, 0, 0] },
      '0:2:0:2:0:1': { orderedDimIndexes: [0, 2, 0, 2, 0, 1] },
      '0:2:0:2:0:2': { orderedDimIndexes: [0, 2, 0, 2, 0, 2] },
      '0:2:0:2:1:0': { orderedDimIndexes: [0, 2, 0, 2, 1, 0] },
      '0:2:0:2:1:1': { orderedDimIndexes: [0, 2, 0, 2, 1, 1] },
      '0:2:0:2:1:2': { orderedDimIndexes: [0, 2, 0, 2, 1, 2] },
      '0:2:0:2:2:0': { orderedDimIndexes: [0, 2, 0, 2, 2, 0] },
      '0:2:0:2:2:1': { orderedDimIndexes: [0, 2, 0, 2, 2, 1] },
      '0:2:0:2:2:2': { orderedDimIndexes: [0, 2, 0, 2, 2, 2] },
      '0:2:1:0:0:0': { orderedDimIndexes: [0, 2, 1, 0, 0, 0] },
      '0:2:1:0:0:1': { orderedDimIndexes: [0, 2, 1, 0, 0, 1] },
      '0:2:1:0:0:2': { orderedDimIndexes: [0, 2, 1, 0, 0, 2] },
      '0:2:1:0:1:0': { orderedDimIndexes: [0, 2, 1, 0, 1, 0] },
      '0:2:1:0:1:1': { orderedDimIndexes: [0, 2, 1, 0, 1, 1] },
      '0:2:1:0:1:2': { orderedDimIndexes: [0, 2, 1, 0, 1, 2] },
      '0:2:1:0:2:0': { orderedDimIndexes: [0, 2, 1, 0, 2, 0] },
      '0:2:1:0:2:1': { orderedDimIndexes: [0, 2, 1, 0, 2, 1] },
      '0:2:1:0:2:2': { orderedDimIndexes: [0, 2, 1, 0, 2, 2] },
      '0:2:1:1:0:0': { orderedDimIndexes: [0, 2, 1, 1, 0, 0] },
      '0:2:1:1:0:1': { orderedDimIndexes: [0, 2, 1, 1, 0, 1] },
      '0:2:1:1:0:2': { orderedDimIndexes: [0, 2, 1, 1, 0, 2] },
      '0:2:1:1:1:0': { orderedDimIndexes: [0, 2, 1, 1, 1, 0] },
      '0:2:1:1:1:1': { orderedDimIndexes: [0, 2, 1, 1, 1, 1] },
      '0:2:1:1:1:2': { orderedDimIndexes: [0, 2, 1, 1, 1, 2] },
      '0:2:1:1:2:0': { orderedDimIndexes: [0, 2, 1, 1, 2, 0] },
      '0:2:1:1:2:1': { orderedDimIndexes: [0, 2, 1, 1, 2, 1] },
      '0:2:1:1:2:2': { orderedDimIndexes: [0, 2, 1, 1, 2, 2] },
      '0:2:1:2:0:0': { orderedDimIndexes: [0, 2, 1, 2, 0, 0] },
      '0:2:1:2:0:1': { orderedDimIndexes: [0, 2, 1, 2, 0, 1] },
      '0:2:1:2:0:2': { orderedDimIndexes: [0, 2, 1, 2, 0, 2] },
      '0:2:1:2:1:0': { orderedDimIndexes: [0, 2, 1, 2, 1, 0] },
      '0:2:1:2:1:1': { orderedDimIndexes: [0, 2, 1, 2, 1, 1] },
      '0:2:1:2:1:2': { orderedDimIndexes: [0, 2, 1, 2, 1, 2] },
      '0:2:1:2:2:0': { orderedDimIndexes: [0, 2, 1, 2, 2, 0] },
      '0:2:1:2:2:1': { orderedDimIndexes: [0, 2, 1, 2, 2, 1] },
      '0:2:1:2:2:2': { orderedDimIndexes: [0, 2, 1, 2, 2, 2] },
      '0:2:2:0:0:0': { orderedDimIndexes: [0, 2, 2, 0, 0, 0] },
      '0:2:2:0:0:1': { orderedDimIndexes: [0, 2, 2, 0, 0, 1] },
      '0:2:2:0:0:2': { orderedDimIndexes: [0, 2, 2, 0, 0, 2] },
      '0:2:2:0:1:0': { orderedDimIndexes: [0, 2, 2, 0, 1, 0] },
      '0:2:2:0:1:1': { orderedDimIndexes: [0, 2, 2, 0, 1, 1] },
      '0:2:2:0:1:2': { orderedDimIndexes: [0, 2, 2, 0, 1, 2] },
      '0:2:2:0:2:0': { orderedDimIndexes: [0, 2, 2, 0, 2, 0] },
      '0:2:2:0:2:1': { orderedDimIndexes: [0, 2, 2, 0, 2, 1] },
      '0:2:2:0:2:2': { orderedDimIndexes: [0, 2, 2, 0, 2, 2] },
      '0:2:2:1:0:0': { orderedDimIndexes: [0, 2, 2, 1, 0, 0] },
      '0:2:2:1:0:1': { orderedDimIndexes: [0, 2, 2, 1, 0, 1] },
      '0:2:2:1:0:2': { orderedDimIndexes: [0, 2, 2, 1, 0, 2] },
      '0:2:2:1:1:0': { orderedDimIndexes: [0, 2, 2, 1, 1, 0] },
      '0:2:2:1:1:1': { orderedDimIndexes: [0, 2, 2, 1, 1, 1] },
      '0:2:2:1:1:2': { orderedDimIndexes: [0, 2, 2, 1, 1, 2] },
      '0:2:2:1:2:0': { orderedDimIndexes: [0, 2, 2, 1, 2, 0] },
      '0:2:2:1:2:1': { orderedDimIndexes: [0, 2, 2, 1, 2, 1] },
      '0:2:2:1:2:2': { orderedDimIndexes: [0, 2, 2, 1, 2, 2] },
      '0:2:2:2:0:0': { orderedDimIndexes: [0, 2, 2, 2, 0, 0] },
      '0:2:2:2:0:1': { orderedDimIndexes: [0, 2, 2, 2, 0, 1] },
      '0:2:2:2:0:2': { orderedDimIndexes: [0, 2, 2, 2, 0, 2] },
      '0:2:2:2:1:0': { orderedDimIndexes: [0, 2, 2, 2, 1, 0] },
      '0:2:2:2:1:1': { orderedDimIndexes: [0, 2, 2, 2, 1, 1] },
      '0:2:2:2:1:2': { orderedDimIndexes: [0, 2, 2, 2, 1, 2] },
      '0:2:2:2:2:0': { orderedDimIndexes: [0, 2, 2, 2, 2, 0] },
      '0:2:2:2:2:1': { orderedDimIndexes: [0, 2, 2, 2, 2, 1] },
      '0:2:2:2:2:2': { orderedDimIndexes: [0, 2, 2, 2, 2, 2] },
      '1:0:0:0:0:0': { orderedDimIndexes: [1, 0, 0, 0, 0, 0] },
      '1:0:0:0:0:1': { orderedDimIndexes: [1, 0, 0, 0, 0, 1] },
      '1:0:0:0:0:2': { orderedDimIndexes: [1, 0, 0, 0, 0, 2] },
      '1:0:0:0:1:0': { orderedDimIndexes: [1, 0, 0, 0, 1, 0] },
      '1:0:0:0:1:1': { orderedDimIndexes: [1, 0, 0, 0, 1, 1] },
      '1:0:0:0:1:2': { orderedDimIndexes: [1, 0, 0, 0, 1, 2] },
      '1:0:0:0:2:0': { orderedDimIndexes: [1, 0, 0, 0, 2, 0] },
      '1:0:0:0:2:1': { orderedDimIndexes: [1, 0, 0, 0, 2, 1] },
      '1:0:0:0:2:2': { orderedDimIndexes: [1, 0, 0, 0, 2, 2] },
      '1:0:0:1:0:0': { orderedDimIndexes: [1, 0, 0, 1, 0, 0] },
      '1:0:0:1:0:1': { orderedDimIndexes: [1, 0, 0, 1, 0, 1] },
      '1:0:0:1:0:2': { orderedDimIndexes: [1, 0, 0, 1, 0, 2] },
      '1:0:0:1:1:0': { orderedDimIndexes: [1, 0, 0, 1, 1, 0] },
      '1:0:0:1:1:1': { orderedDimIndexes: [1, 0, 0, 1, 1, 1] },
      '1:0:0:1:1:2': { orderedDimIndexes: [1, 0, 0, 1, 1, 2] },
      '1:0:0:1:2:0': { orderedDimIndexes: [1, 0, 0, 1, 2, 0] },
      '1:0:0:1:2:1': { orderedDimIndexes: [1, 0, 0, 1, 2, 1] },
      '1:0:0:1:2:2': { orderedDimIndexes: [1, 0, 0, 1, 2, 2] },
      '1:0:0:2:0:0': { orderedDimIndexes: [1, 0, 0, 2, 0, 0] },
      '1:0:0:2:0:1': { orderedDimIndexes: [1, 0, 0, 2, 0, 1] },
      '1:0:0:2:0:2': { orderedDimIndexes: [1, 0, 0, 2, 0, 2] },
      '1:0:0:2:1:0': { orderedDimIndexes: [1, 0, 0, 2, 1, 0] },
      '1:0:0:2:1:1': { orderedDimIndexes: [1, 0, 0, 2, 1, 1] },
      '1:0:0:2:1:2': { orderedDimIndexes: [1, 0, 0, 2, 1, 2] },
      '1:0:0:2:2:0': { orderedDimIndexes: [1, 0, 0, 2, 2, 0] },
      '1:0:0:2:2:1': { orderedDimIndexes: [1, 0, 0, 2, 2, 1] },
      '1:0:0:2:2:2': { orderedDimIndexes: [1, 0, 0, 2, 2, 2] },
      '1:0:1:0:0:0': { orderedDimIndexes: [1, 0, 1, 0, 0, 0] },
      '1:0:1:0:0:1': { orderedDimIndexes: [1, 0, 1, 0, 0, 1] },
      '1:0:1:0:0:2': { orderedDimIndexes: [1, 0, 1, 0, 0, 2] },
      '1:0:1:0:1:0': { orderedDimIndexes: [1, 0, 1, 0, 1, 0] },
      '1:0:1:0:1:1': { orderedDimIndexes: [1, 0, 1, 0, 1, 1] },
      '1:0:1:0:1:2': { orderedDimIndexes: [1, 0, 1, 0, 1, 2] },
      '1:0:1:0:2:0': { orderedDimIndexes: [1, 0, 1, 0, 2, 0] },
      '1:0:1:0:2:1': { orderedDimIndexes: [1, 0, 1, 0, 2, 1] },
      '1:0:1:0:2:2': { orderedDimIndexes: [1, 0, 1, 0, 2, 2] },
      '1:0:1:1:0:0': { orderedDimIndexes: [1, 0, 1, 1, 0, 0] },
      '1:0:1:1:0:1': { orderedDimIndexes: [1, 0, 1, 1, 0, 1] },
      '1:0:1:1:0:2': { orderedDimIndexes: [1, 0, 1, 1, 0, 2] },
      '1:0:1:1:1:0': { orderedDimIndexes: [1, 0, 1, 1, 1, 0] },
      '1:0:1:1:1:1': { orderedDimIndexes: [1, 0, 1, 1, 1, 1] },
      '1:0:1:1:1:2': { orderedDimIndexes: [1, 0, 1, 1, 1, 2] },
      '1:0:1:1:2:0': { orderedDimIndexes: [1, 0, 1, 1, 2, 0] },
      '1:0:1:1:2:1': { orderedDimIndexes: [1, 0, 1, 1, 2, 1] },
      '1:0:1:1:2:2': { orderedDimIndexes: [1, 0, 1, 1, 2, 2] },
      '1:0:1:2:0:0': { orderedDimIndexes: [1, 0, 1, 2, 0, 0] },
      '1:0:1:2:0:1': { orderedDimIndexes: [1, 0, 1, 2, 0, 1] },
      '1:0:1:2:0:2': { orderedDimIndexes: [1, 0, 1, 2, 0, 2] },
      '1:0:1:2:1:0': { orderedDimIndexes: [1, 0, 1, 2, 1, 0] },
      '1:0:1:2:1:1': { orderedDimIndexes: [1, 0, 1, 2, 1, 1] },
      '1:0:1:2:2:0': { orderedDimIndexes: [1, 0, 1, 2, 2, 0] },
      '1:0:1:2:2:1': { orderedDimIndexes: [1, 0, 1, 2, 2, 1] },
      '1:0:1:2:2:2': { orderedDimIndexes: [1, 0, 1, 2, 2, 2] },
      '1:0:2:0:0:0': { orderedDimIndexes: [1, 0, 2, 0, 0, 0] },
      '1:0:2:0:0:1': { orderedDimIndexes: [1, 0, 2, 0, 0, 1] },
      '1:0:2:0:0:2': { orderedDimIndexes: [1, 0, 2, 0, 0, 2] },
      '1:0:2:0:1:0': { orderedDimIndexes: [1, 0, 2, 0, 1, 0] },
      '1:0:2:0:1:1': { orderedDimIndexes: [1, 0, 2, 0, 1, 1] },
      '1:0:2:0:1:2': { orderedDimIndexes: [1, 0, 2, 0, 1, 2] },
      '1:0:2:0:2:0': { orderedDimIndexes: [1, 0, 2, 0, 2, 0] },
      '1:0:2:0:2:1': { orderedDimIndexes: [1, 0, 2, 0, 2, 1] },
      '1:0:2:0:2:2': { orderedDimIndexes: [1, 0, 2, 0, 2, 2] },
      '1:0:2:1:0:0': { orderedDimIndexes: [1, 0, 2, 1, 0, 0] },
      '1:0:2:1:0:1': { orderedDimIndexes: [1, 0, 2, 1, 0, 1] },
      '1:0:2:1:0:2': { orderedDimIndexes: [1, 0, 2, 1, 0, 2] },
      '1:0:2:1:1:0': { orderedDimIndexes: [1, 0, 2, 1, 1, 0] },
      '1:0:2:1:1:1': { orderedDimIndexes: [1, 0, 2, 1, 1, 1] },
      '1:0:2:1:1:2': { orderedDimIndexes: [1, 0, 2, 1, 1, 2] },
      '1:0:2:1:2:0': { orderedDimIndexes: [1, 0, 2, 1, 2, 0] },
      '1:0:2:1:2:1': { orderedDimIndexes: [1, 0, 2, 1, 2, 1] },
      '1:0:2:1:2:2': { orderedDimIndexes: [1, 0, 2, 1, 2, 2] },
      '1:0:2:2:0:0': { orderedDimIndexes: [1, 0, 2, 2, 0, 0] },
      '1:0:2:2:0:1': { orderedDimIndexes: [1, 0, 2, 2, 0, 1] },
      '1:0:2:2:0:2': { orderedDimIndexes: [1, 0, 2, 2, 0, 2] },
      '1:0:2:2:1:0': { orderedDimIndexes: [1, 0, 2, 2, 1, 0] },
      '1:0:2:2:1:1': { orderedDimIndexes: [1, 0, 2, 2, 1, 1] },
      '1:0:2:2:1:2': { orderedDimIndexes: [1, 0, 2, 2, 1, 2] },
      '1:0:2:2:2:0': { orderedDimIndexes: [1, 0, 2, 2, 2, 0] },
      '1:0:2:2:2:1': { orderedDimIndexes: [1, 0, 2, 2, 2, 1] },
      '1:0:2:2:2:2': { orderedDimIndexes: [1, 0, 2, 2, 2, 2] },
      '1:1:0:0:0:0': { orderedDimIndexes: [1, 1, 0, 0, 0, 0] },
      '1:1:0:0:0:1': { orderedDimIndexes: [1, 1, 0, 0, 0, 1] },
      '1:1:0:0:0:2': { orderedDimIndexes: [1, 1, 0, 0, 0, 2] },
      '1:1:0:0:1:0': { orderedDimIndexes: [1, 1, 0, 0, 1, 0] },
      '1:1:0:0:1:1': { orderedDimIndexes: [1, 1, 0, 0, 1, 1] },
      '1:1:0:0:1:2': { orderedDimIndexes: [1, 1, 0, 0, 1, 2] },
      '1:1:0:0:2:0': { orderedDimIndexes: [1, 1, 0, 0, 2, 0] },
      '1:1:0:0:2:1': { orderedDimIndexes: [1, 1, 0, 0, 2, 1] },
      '1:1:0:0:2:2': { orderedDimIndexes: [1, 1, 0, 0, 2, 2] },
      '1:1:0:1:0:0': { orderedDimIndexes: [1, 1, 0, 1, 0, 0] },
      '1:1:0:1:0:1': { orderedDimIndexes: [1, 1, 0, 1, 0, 1] },
      '1:1:0:1:0:2': { orderedDimIndexes: [1, 1, 0, 1, 0, 2] },
      '1:1:0:1:1:0': { orderedDimIndexes: [1, 1, 0, 1, 1, 0] },
      '1:1:0:1:1:1': { orderedDimIndexes: [1, 1, 0, 1, 1, 1] },
      '1:1:0:1:1:2': { orderedDimIndexes: [1, 1, 0, 1, 1, 2] },
      '1:1:0:1:2:0': { orderedDimIndexes: [1, 1, 0, 1, 2, 0] },
      '1:1:0:1:2:1': { orderedDimIndexes: [1, 1, 0, 1, 2, 1] },
      '1:1:0:1:2:2': { orderedDimIndexes: [1, 1, 0, 1, 2, 2] },
      '1:1:0:2:0:0': { orderedDimIndexes: [1, 1, 0, 2, 0, 0] },
      '1:1:0:2:0:1': { orderedDimIndexes: [1, 1, 0, 2, 0, 1] },
      '1:1:0:2:0:2': { orderedDimIndexes: [1, 1, 0, 2, 0, 2] },
      '1:1:0:2:1:0': { orderedDimIndexes: [1, 1, 0, 2, 1, 0] },
      '1:1:0:2:1:1': { orderedDimIndexes: [1, 1, 0, 2, 1, 1] },
      '1:1:0:2:1:2': { orderedDimIndexes: [1, 1, 0, 2, 1, 2] },
      '1:1:0:2:2:0': { orderedDimIndexes: [1, 1, 0, 2, 2, 0] },
      '1:1:0:2:2:1': { orderedDimIndexes: [1, 1, 0, 2, 2, 1] },
      '1:1:0:2:2:2': { orderedDimIndexes: [1, 1, 0, 2, 2, 2] },
      '1:1:1:0:0:0': { orderedDimIndexes: [1, 1, 1, 0, 0, 0] },
      '1:1:1:0:0:1': { orderedDimIndexes: [1, 1, 1, 0, 0, 1] },
      '1:1:1:0:0:2': { orderedDimIndexes: [1, 1, 1, 0, 0, 2] },
      '1:1:1:0:1:0': { orderedDimIndexes: [1, 1, 1, 0, 1, 0] },
      '1:1:1:0:1:1': { orderedDimIndexes: [1, 1, 1, 0, 1, 1] },
      '1:1:1:0:1:2': { orderedDimIndexes: [1, 1, 1, 0, 1, 2] },
      '1:1:1:0:2:0': { orderedDimIndexes: [1, 1, 1, 0, 2, 0] },
      '1:1:1:0:2:1': { orderedDimIndexes: [1, 1, 1, 0, 2, 1] },
      '1:1:1:0:2:2': { orderedDimIndexes: [1, 1, 1, 0, 2, 2] },
      '1:1:1:1:0:0': { orderedDimIndexes: [1, 1, 1, 1, 0, 0] },
      '1:1:1:1:0:1': { orderedDimIndexes: [1, 1, 1, 1, 0, 1] },
      '1:1:1:1:0:2': { orderedDimIndexes: [1, 1, 1, 1, 0, 2] },
      '1:1:1:1:1:0': { orderedDimIndexes: [1, 1, 1, 1, 1, 0] },
      '1:1:1:1:1:1': { orderedDimIndexes: [1, 1, 1, 1, 1, 1] },
      '1:1:1:1:1:2': { orderedDimIndexes: [1, 1, 1, 1, 1, 2] },
      '1:1:1:1:2:0': { orderedDimIndexes: [1, 1, 1, 1, 2, 0] },
      '1:1:1:1:2:1': { orderedDimIndexes: [1, 1, 1, 1, 2, 1] },
      '1:1:1:1:2:2': { orderedDimIndexes: [1, 1, 1, 1, 2, 2] },
      '1:1:1:2:0:0': { orderedDimIndexes: [1, 1, 1, 2, 0, 0] },
      '1:1:1:2:0:1': { orderedDimIndexes: [1, 1, 1, 2, 0, 1] },
      '1:1:1:2:0:2': { orderedDimIndexes: [1, 1, 1, 2, 0, 2] },
      '1:1:1:2:1:0': { orderedDimIndexes: [1, 1, 1, 2, 1, 0] },
      '1:1:1:2:1:1': { orderedDimIndexes: [1, 1, 1, 2, 1, 1] },
      '1:1:1:2:1:2': { orderedDimIndexes: [1, 1, 1, 2, 1, 2] },
      '1:1:1:2:2:0': { orderedDimIndexes: [1, 1, 1, 2, 2, 0] },
      '1:1:1:2:2:1': { orderedDimIndexes: [1, 1, 1, 2, 2, 1] },
      '1:1:1:2:2:2': { orderedDimIndexes: [1, 1, 1, 2, 2, 2] },
      '1:1:2:0:0:0': { orderedDimIndexes: [1, 1, 2, 0, 0, 0] },
      '1:1:2:0:0:1': { orderedDimIndexes: [1, 1, 2, 0, 0, 1] },
      '1:1:2:0:0:2': { orderedDimIndexes: [1, 1, 2, 0, 0, 2] },
      '1:1:2:0:1:0': { orderedDimIndexes: [1, 1, 2, 0, 1, 0] },
      '1:1:2:0:1:1': { orderedDimIndexes: [1, 1, 2, 0, 1, 1] },
      '1:1:2:0:1:2': { orderedDimIndexes: [1, 1, 2, 0, 1, 2] },
      '1:1:2:0:2:0': { orderedDimIndexes: [1, 1, 2, 0, 2, 0] },
      '1:1:2:0:2:1': { orderedDimIndexes: [1, 1, 2, 0, 2, 1] },
      '1:1:2:0:2:2': { orderedDimIndexes: [1, 1, 2, 0, 2, 2] },
      '1:1:2:1:0:0': { orderedDimIndexes: [1, 1, 2, 1, 0, 0] },
      '1:1:2:1:0:1': { orderedDimIndexes: [1, 1, 2, 1, 0, 1] },
      '1:1:2:1:0:2': { orderedDimIndexes: [1, 1, 2, 1, 0, 2] },
      '1:1:2:1:1:0': { orderedDimIndexes: [1, 1, 2, 1, 1, 0] },
      '1:1:2:1:1:1': { orderedDimIndexes: [1, 1, 2, 1, 1, 1] },
      '1:1:2:1:1:2': { orderedDimIndexes: [1, 1, 2, 1, 1, 2] },
      '1:1:2:1:2:0': { orderedDimIndexes: [1, 1, 2, 1, 2, 0] },
      '1:1:2:1:2:1': { orderedDimIndexes: [1, 1, 2, 1, 2, 1] },
      '1:1:2:1:2:2': { orderedDimIndexes: [1, 1, 2, 1, 2, 2] },
      '1:1:2:2:0:0': { orderedDimIndexes: [1, 1, 2, 2, 0, 0] },
      '1:1:2:2:0:1': { orderedDimIndexes: [1, 1, 2, 2, 0, 1] },
      '1:1:2:2:0:2': { orderedDimIndexes: [1, 1, 2, 2, 0, 2] },
      '1:1:2:2:1:0': { orderedDimIndexes: [1, 1, 2, 2, 1, 0] },
      '1:1:2:2:1:1': { orderedDimIndexes: [1, 1, 2, 2, 1, 1] },
      '1:1:2:2:1:2': { orderedDimIndexes: [1, 1, 2, 2, 1, 2] },
      '1:1:2:2:2:0': { orderedDimIndexes: [1, 1, 2, 2, 2, 0] },
      '1:1:2:2:2:1': { orderedDimIndexes: [1, 1, 2, 2, 2, 1] },
      '1:1:2:2:2:2': { orderedDimIndexes: [1, 1, 2, 2, 2, 2] },
      '1:2:0:0:0:0': { orderedDimIndexes: [1, 2, 0, 0, 0, 0] },
      '1:2:0:0:0:1': { orderedDimIndexes: [1, 2, 0, 0, 0, 1] },
      '1:2:0:0:0:2': { orderedDimIndexes: [1, 2, 0, 0, 0, 2] },
      '1:2:0:0:1:0': { orderedDimIndexes: [1, 2, 0, 0, 1, 0] },
      '1:2:0:0:1:1': { orderedDimIndexes: [1, 2, 0, 0, 1, 1] },
      '1:2:0:0:1:2': { orderedDimIndexes: [1, 2, 0, 0, 1, 2] },
      '1:2:0:0:2:0': { orderedDimIndexes: [1, 2, 0, 0, 2, 0] },
      '1:2:0:0:2:1': { orderedDimIndexes: [1, 2, 0, 0, 2, 1] },
      '1:2:0:0:2:2': { orderedDimIndexes: [1, 2, 0, 0, 2, 2] },
      '1:2:0:1:0:0': { orderedDimIndexes: [1, 2, 0, 1, 0, 0] },
      '1:2:0:1:0:1': { orderedDimIndexes: [1, 2, 0, 1, 0, 1] },
      '1:2:0:1:0:2': { orderedDimIndexes: [1, 2, 0, 1, 0, 2] },
      '1:2:0:1:1:0': { orderedDimIndexes: [1, 2, 0, 1, 1, 0] },
      '1:2:0:1:1:1': { orderedDimIndexes: [1, 2, 0, 1, 1, 1] },
      '1:2:0:1:1:2': { orderedDimIndexes: [1, 2, 0, 1, 1, 2] },
      '1:2:0:1:2:0': { orderedDimIndexes: [1, 2, 0, 1, 2, 0] },
      '1:2:0:1:2:1': { orderedDimIndexes: [1, 2, 0, 1, 2, 1] },
      '1:2:0:1:2:2': { orderedDimIndexes: [1, 2, 0, 1, 2, 2] },
      '1:2:0:2:0:0': { orderedDimIndexes: [1, 2, 0, 2, 0, 0] },
      '1:2:0:2:0:1': { orderedDimIndexes: [1, 2, 0, 2, 0, 1] },
      '1:2:0:2:0:2': { orderedDimIndexes: [1, 2, 0, 2, 0, 2] },
      '1:2:0:2:1:0': { orderedDimIndexes: [1, 2, 0, 2, 1, 0] },
      '1:2:0:2:1:1': { orderedDimIndexes: [1, 2, 0, 2, 1, 1] },
      '1:2:0:2:1:2': { orderedDimIndexes: [1, 2, 0, 2, 1, 2] },
      '1:2:0:2:2:0': { orderedDimIndexes: [1, 2, 0, 2, 2, 0] },
      '1:2:0:2:2:1': { orderedDimIndexes: [1, 2, 0, 2, 2, 1] },
      '1:2:0:2:2:2': { orderedDimIndexes: [1, 2, 0, 2, 2, 2] },
      '1:2:1:0:0:0': { orderedDimIndexes: [1, 2, 1, 0, 0, 0] },
      '1:2:1:0:0:1': { orderedDimIndexes: [1, 2, 1, 0, 0, 1] },
      '1:2:1:0:0:2': { orderedDimIndexes: [1, 2, 1, 0, 0, 2] },
      '1:2:1:0:1:0': { orderedDimIndexes: [1, 2, 1, 0, 1, 0] },
      '1:2:1:0:1:1': { orderedDimIndexes: [1, 2, 1, 0, 1, 1] },
      '1:2:1:0:1:2': { orderedDimIndexes: [1, 2, 1, 0, 1, 2] },
      '1:2:1:0:2:0': { orderedDimIndexes: [1, 2, 1, 0, 2, 0] },
      '1:2:1:0:2:1': { orderedDimIndexes: [1, 2, 1, 0, 2, 1] },
      '1:2:1:0:2:2': { orderedDimIndexes: [1, 2, 1, 0, 2, 2] },
      '1:2:1:1:0:0': { orderedDimIndexes: [1, 2, 1, 1, 0, 0] },
      '1:2:1:1:0:1': { orderedDimIndexes: [1, 2, 1, 1, 0, 1] },
      '1:2:1:1:0:2': { orderedDimIndexes: [1, 2, 1, 1, 0, 2] },
      '1:2:1:1:1:0': { orderedDimIndexes: [1, 2, 1, 1, 1, 0] },
      '1:2:1:1:1:1': { orderedDimIndexes: [1, 2, 1, 1, 1, 1] },
      '1:2:1:1:1:2': { orderedDimIndexes: [1, 2, 1, 1, 1, 2] },
      '1:2:1:1:2:0': { orderedDimIndexes: [1, 2, 1, 1, 2, 0] },
      '1:2:1:1:2:1': { orderedDimIndexes: [1, 2, 1, 1, 2, 1] },
      '1:2:1:1:2:2': { orderedDimIndexes: [1, 2, 1, 1, 2, 2] },
      '1:2:1:2:0:0': { orderedDimIndexes: [1, 2, 1, 2, 0, 0] },
      '1:2:1:2:0:1': { orderedDimIndexes: [1, 2, 1, 2, 0, 1] },
      '1:2:1:2:0:2': { orderedDimIndexes: [1, 2, 1, 2, 0, 2] },
      '1:2:1:2:1:0': { orderedDimIndexes: [1, 2, 1, 2, 1, 0] },
      '1:2:1:2:1:1': { orderedDimIndexes: [1, 2, 1, 2, 1, 1] },
      '1:2:1:2:1:2': { orderedDimIndexes: [1, 2, 1, 2, 1, 2] },
      '1:2:1:2:2:0': { orderedDimIndexes: [1, 2, 1, 2, 2, 0] },
      '1:2:1:2:2:1': { orderedDimIndexes: [1, 2, 1, 2, 2, 1] },
      '1:2:1:2:2:2': { orderedDimIndexes: [1, 2, 1, 2, 2, 2] },
      '1:2:2:0:0:0': { orderedDimIndexes: [1, 2, 2, 0, 0, 0] },
      '1:2:2:0:0:1': { orderedDimIndexes: [1, 2, 2, 0, 0, 1] },
      '1:2:2:0:0:2': { orderedDimIndexes: [1, 2, 2, 0, 0, 2] },
      '1:2:2:0:1:0': { orderedDimIndexes: [1, 2, 2, 0, 1, 0] },
      '1:2:2:0:1:1': { orderedDimIndexes: [1, 2, 2, 0, 1, 1] },
      '1:2:2:0:1:2': { orderedDimIndexes: [1, 2, 2, 0, 1, 2] },
      '1:2:2:0:2:0': { orderedDimIndexes: [1, 2, 2, 0, 2, 0] },
      '1:2:2:0:2:1': { orderedDimIndexes: [1, 2, 2, 0, 2, 1] },
      '1:2:2:0:2:2': { orderedDimIndexes: [1, 2, 2, 0, 2, 2] },
      '1:2:2:1:0:0': { orderedDimIndexes: [1, 2, 2, 1, 0, 0] },
      '1:2:2:1:0:1': { orderedDimIndexes: [1, 2, 2, 1, 0, 1] },
      '1:2:2:1:0:2': { orderedDimIndexes: [1, 2, 2, 1, 0, 2] },
      '1:2:2:1:1:0': { orderedDimIndexes: [1, 2, 2, 1, 1, 0] },
      '1:2:2:1:1:1': { orderedDimIndexes: [1, 2, 2, 1, 1, 1] },
      '1:2:2:1:1:2': { orderedDimIndexes: [1, 2, 2, 1, 1, 2] },
      '1:2:2:1:2:0': { orderedDimIndexes: [1, 2, 2, 1, 2, 0] },
      '1:2:2:1:2:1': { orderedDimIndexes: [1, 2, 2, 1, 2, 1] },
      '1:2:2:1:2:2': { orderedDimIndexes: [1, 2, 2, 1, 2, 2] },
      '1:2:2:2:0:0': { orderedDimIndexes: [1, 2, 2, 2, 0, 0] },
      '1:2:2:2:0:1': { orderedDimIndexes: [1, 2, 2, 2, 0, 1] },
      '1:2:2:2:0:2': { orderedDimIndexes: [1, 2, 2, 2, 0, 2] },
      '1:2:2:2:1:0': { orderedDimIndexes: [1, 2, 2, 2, 1, 0] },
      '1:2:2:2:1:1': { orderedDimIndexes: [1, 2, 2, 2, 1, 1] },
      '1:2:2:2:1:2': { orderedDimIndexes: [1, 2, 2, 2, 1, 2] },
      '1:2:2:2:2:0': { orderedDimIndexes: [1, 2, 2, 2, 2, 0] },
      '1:2:2:2:2:1': { orderedDimIndexes: [1, 2, 2, 2, 2, 1] },
      '1:2:2:2:2:2': { orderedDimIndexes: [1, 2, 2, 2, 2, 2] },
      '2:0:0:0:0:0': { orderedDimIndexes: [2, 0, 0, 0, 0, 0] },
      '2:0:0:0:0:1': { orderedDimIndexes: [2, 0, 0, 0, 0, 1] },
      '2:0:0:0:0:2': { orderedDimIndexes: [2, 0, 0, 0, 0, 2] },
      '2:0:0:0:1:0': { orderedDimIndexes: [2, 0, 0, 0, 1, 0] },
      '2:0:0:0:1:1': { orderedDimIndexes: [2, 0, 0, 0, 1, 1] },
      '2:0:0:0:1:2': { orderedDimIndexes: [2, 0, 0, 0, 1, 2] },
      '2:0:0:0:2:0': { orderedDimIndexes: [2, 0, 0, 0, 2, 0] },
      '2:0:0:0:2:1': { orderedDimIndexes: [2, 0, 0, 0, 2, 1] },
      '2:0:0:0:2:2': { orderedDimIndexes: [2, 0, 0, 0, 2, 2] },
      '2:0:0:1:0:0': { orderedDimIndexes: [2, 0, 0, 1, 0, 0] },
      '2:0:0:1:0:1': { orderedDimIndexes: [2, 0, 0, 1, 0, 1] },
      '2:0:0:1:0:2': { orderedDimIndexes: [2, 0, 0, 1, 0, 2] },
      '2:0:0:1:1:0': { orderedDimIndexes: [2, 0, 0, 1, 1, 0] },
      '2:0:0:1:1:1': { orderedDimIndexes: [2, 0, 0, 1, 1, 1] },
      '2:0:0:1:1:2': { orderedDimIndexes: [2, 0, 0, 1, 1, 2] },
      '2:0:0:1:2:0': { orderedDimIndexes: [2, 0, 0, 1, 2, 0] },
      '2:0:0:1:2:1': { orderedDimIndexes: [2, 0, 0, 1, 2, 1] },
      '2:0:0:1:2:2': { orderedDimIndexes: [2, 0, 0, 1, 2, 2] },
      '2:0:0:2:0:0': { orderedDimIndexes: [2, 0, 0, 2, 0, 0] },
      '2:0:0:2:0:1': { orderedDimIndexes: [2, 0, 0, 2, 0, 1] },
      '2:0:0:2:0:2': { orderedDimIndexes: [2, 0, 0, 2, 0, 2] },
      '2:0:0:2:1:0': { orderedDimIndexes: [2, 0, 0, 2, 1, 0] },
      '2:0:0:2:1:1': { orderedDimIndexes: [2, 0, 0, 2, 1, 1] },
      '2:0:0:2:1:2': { orderedDimIndexes: [2, 0, 0, 2, 1, 2] },
      '2:0:0:2:2:0': { orderedDimIndexes: [2, 0, 0, 2, 2, 0] },
      '2:0:0:2:2:1': { orderedDimIndexes: [2, 0, 0, 2, 2, 1] },
      '2:0:0:2:2:2': { orderedDimIndexes: [2, 0, 0, 2, 2, 2] },
      '2:0:1:0:0:0': { orderedDimIndexes: [2, 0, 1, 0, 0, 0] },
      '2:0:1:0:0:1': { orderedDimIndexes: [2, 0, 1, 0, 0, 1] },
      '2:0:1:0:0:2': { orderedDimIndexes: [2, 0, 1, 0, 0, 2] },
      '2:0:1:0:1:0': { orderedDimIndexes: [2, 0, 1, 0, 1, 0] },
      '2:0:1:0:1:1': { orderedDimIndexes: [2, 0, 1, 0, 1, 1] },
      '2:0:1:0:1:2': { orderedDimIndexes: [2, 0, 1, 0, 1, 2] },
      '2:0:1:0:2:0': { orderedDimIndexes: [2, 0, 1, 0, 2, 0] },
      '2:0:1:0:2:1': { orderedDimIndexes: [2, 0, 1, 0, 2, 1] },
      '2:0:1:0:2:2': { orderedDimIndexes: [2, 0, 1, 0, 2, 2] },
      '2:0:1:1:0:0': { orderedDimIndexes: [2, 0, 1, 1, 0, 0] },
      '2:0:1:1:0:1': { orderedDimIndexes: [2, 0, 1, 1, 0, 1] },
      '2:0:1:1:0:2': { orderedDimIndexes: [2, 0, 1, 1, 0, 2] },
      '2:0:1:1:1:0': { orderedDimIndexes: [2, 0, 1, 1, 1, 0] },
      '2:0:1:1:1:1': { orderedDimIndexes: [2, 0, 1, 1, 1, 1] },
      '2:0:1:1:1:2': { orderedDimIndexes: [2, 0, 1, 1, 1, 2] },
      '2:0:1:1:2:0': { orderedDimIndexes: [2, 0, 1, 1, 2, 0] },
      '2:0:1:1:2:1': { orderedDimIndexes: [2, 0, 1, 1, 2, 1] },
      '2:0:1:1:2:2': { orderedDimIndexes: [2, 0, 1, 1, 2, 2] },
      '2:0:1:2:0:0': { orderedDimIndexes: [2, 0, 1, 2, 0, 0] },
      '2:0:1:2:0:1': { orderedDimIndexes: [2, 0, 1, 2, 0, 1] },
      '2:0:1:2:0:2': { orderedDimIndexes: [2, 0, 1, 2, 0, 2] },
      '2:0:1:2:1:0': { orderedDimIndexes: [2, 0, 1, 2, 1, 0] },
      '2:0:1:2:1:1': { orderedDimIndexes: [2, 0, 1, 2, 1, 1] },
      '2:0:1:2:2:0': { orderedDimIndexes: [2, 0, 1, 2, 2, 0] },
      '2:0:1:2:2:1': { orderedDimIndexes: [2, 0, 1, 2, 2, 1] },
      '2:0:1:2:2:2': { orderedDimIndexes: [2, 0, 1, 2, 2, 2] },
      '2:0:2:0:0:0': { orderedDimIndexes: [2, 0, 2, 0, 0, 0] },
      '2:0:2:0:0:1': { orderedDimIndexes: [2, 0, 2, 0, 0, 1] },
      '2:0:2:0:0:2': { orderedDimIndexes: [2, 0, 2, 0, 0, 2] },
      '2:0:2:0:1:0': { orderedDimIndexes: [2, 0, 2, 0, 1, 0] },
      '2:0:2:0:1:1': { orderedDimIndexes: [2, 0, 2, 0, 1, 1] },
      '2:0:2:0:1:2': { orderedDimIndexes: [2, 0, 2, 0, 1, 2] },
      '2:0:2:0:2:0': { orderedDimIndexes: [2, 0, 2, 0, 2, 0] },
      '2:0:2:0:2:1': { orderedDimIndexes: [2, 0, 2, 0, 2, 1] },
      '2:0:2:0:2:2': { orderedDimIndexes: [2, 0, 2, 0, 2, 2] },
      '2:0:2:1:0:0': { orderedDimIndexes: [2, 0, 2, 1, 0, 0] },
      '2:0:2:1:0:1': { orderedDimIndexes: [2, 0, 2, 1, 0, 1] },
      '2:0:2:1:0:2': { orderedDimIndexes: [2, 0, 2, 1, 0, 2] },
      '2:0:2:1:1:0': { orderedDimIndexes: [2, 0, 2, 1, 1, 0] },
      '2:0:2:1:1:1': { orderedDimIndexes: [2, 0, 2, 1, 1, 1] },
      '2:0:2:1:1:2': { orderedDimIndexes: [2, 0, 2, 1, 1, 2] },
      '2:0:2:1:2:0': { orderedDimIndexes: [2, 0, 2, 1, 2, 0] },
      '2:0:2:1:2:1': { orderedDimIndexes: [2, 0, 2, 1, 2, 1] },
      '2:0:2:1:2:2': { orderedDimIndexes: [2, 0, 2, 1, 2, 2] },
      '2:0:2:2:0:0': { orderedDimIndexes: [2, 0, 2, 2, 0, 0] },
      '2:0:2:2:0:1': { orderedDimIndexes: [2, 0, 2, 2, 0, 1] },
      '2:0:2:2:0:2': { orderedDimIndexes: [2, 0, 2, 2, 0, 2] },
      '2:0:2:2:1:0': { orderedDimIndexes: [2, 0, 2, 2, 1, 0] },
      '2:0:2:2:1:1': { orderedDimIndexes: [2, 0, 2, 2, 1, 1] },
      '2:0:2:2:1:2': { orderedDimIndexes: [2, 0, 2, 2, 1, 2] },
      '2:0:2:2:2:0': { orderedDimIndexes: [2, 0, 2, 2, 2, 0] },
      '2:0:2:2:2:1': { orderedDimIndexes: [2, 0, 2, 2, 2, 1] },
      '2:0:2:2:2:2': { orderedDimIndexes: [2, 0, 2, 2, 2, 2] },
      '2:1:0:0:0:0': { orderedDimIndexes: [2, 1, 0, 0, 0, 0] },
      '2:1:0:0:0:1': { orderedDimIndexes: [2, 1, 0, 0, 0, 1] },
      '2:1:0:0:0:2': { orderedDimIndexes: [2, 1, 0, 0, 0, 2] },
      '2:1:0:0:1:0': { orderedDimIndexes: [2, 1, 0, 0, 1, 0] },
      '2:1:0:0:1:1': { orderedDimIndexes: [2, 1, 0, 0, 1, 1] },
      '2:1:0:0:1:2': { orderedDimIndexes: [2, 1, 0, 0, 1, 2] },
      '2:1:0:0:2:0': { orderedDimIndexes: [2, 1, 0, 0, 2, 0] },
      '2:1:0:0:2:1': { orderedDimIndexes: [2, 1, 0, 0, 2, 1] },
      '2:1:0:0:2:2': { orderedDimIndexes: [2, 1, 0, 0, 2, 2] },
      '2:1:0:1:0:0': { orderedDimIndexes: [2, 1, 0, 1, 0, 0] },
      '2:1:0:1:0:1': { orderedDimIndexes: [2, 1, 0, 1, 0, 1] },
      '2:1:0:1:0:2': { orderedDimIndexes: [2, 1, 0, 1, 0, 2] },
      '2:1:0:1:1:0': { orderedDimIndexes: [2, 1, 0, 1, 1, 0] },
      '2:1:0:1:1:1': { orderedDimIndexes: [2, 1, 0, 1, 1, 1] },
      '2:1:0:1:1:2': { orderedDimIndexes: [2, 1, 0, 1, 1, 2] },
      '2:1:0:1:2:0': { orderedDimIndexes: [2, 1, 0, 1, 2, 0] },
      '2:1:0:1:2:1': { orderedDimIndexes: [2, 1, 0, 1, 2, 1] },
      '2:1:0:1:2:2': { orderedDimIndexes: [2, 1, 0, 1, 2, 2] },
      '2:1:0:2:0:0': { orderedDimIndexes: [2, 1, 0, 2, 0, 0] },
      '2:1:0:2:0:1': { orderedDimIndexes: [2, 1, 0, 2, 0, 1] },
      '2:1:0:2:0:2': { orderedDimIndexes: [2, 1, 0, 2, 0, 2] },
      '2:1:0:2:1:0': { orderedDimIndexes: [2, 1, 0, 2, 1, 0] },
      '2:1:0:2:1:1': { orderedDimIndexes: [2, 1, 0, 2, 1, 1] },
      '2:1:0:2:1:2': { orderedDimIndexes: [2, 1, 0, 2, 1, 2] },
      '2:1:0:2:2:0': { orderedDimIndexes: [2, 1, 0, 2, 2, 0] },
      '2:1:0:2:2:1': { orderedDimIndexes: [2, 1, 0, 2, 2, 1] },
      '2:1:0:2:2:2': { orderedDimIndexes: [2, 1, 0, 2, 2, 2] },
      '2:1:1:0:0:0': { orderedDimIndexes: [2, 1, 1, 0, 0, 0] },
      '2:1:1:0:0:1': { orderedDimIndexes: [2, 1, 1, 0, 0, 1] },
      '2:1:1:0:0:2': { orderedDimIndexes: [2, 1, 1, 0, 0, 2] },
      '2:1:1:0:1:0': { orderedDimIndexes: [2, 1, 1, 0, 1, 0] },
      '2:1:1:0:1:1': { orderedDimIndexes: [2, 1, 1, 0, 1, 1] },
      '2:1:1:0:1:2': { orderedDimIndexes: [2, 1, 1, 0, 1, 2] },
      '2:1:1:0:2:0': { orderedDimIndexes: [2, 1, 1, 0, 2, 0] },
      '2:1:1:0:2:1': { orderedDimIndexes: [2, 1, 1, 0, 2, 1] },
      '2:1:1:0:2:2': { orderedDimIndexes: [2, 1, 1, 0, 2, 2] },
      '2:1:1:1:0:0': { orderedDimIndexes: [2, 1, 1, 1, 0, 0] },
      '2:1:1:1:0:1': { orderedDimIndexes: [2, 1, 1, 1, 0, 1] },
      '2:1:1:1:0:2': { orderedDimIndexes: [2, 1, 1, 1, 0, 2] },
      '2:1:1:1:1:0': { orderedDimIndexes: [2, 1, 1, 1, 1, 0] },
      '2:1:1:1:1:1': { orderedDimIndexes: [2, 1, 1, 1, 1, 1] },
      '2:1:1:1:1:2': { orderedDimIndexes: [2, 1, 1, 1, 1, 2] },
      '2:1:1:1:2:0': { orderedDimIndexes: [2, 1, 1, 1, 2, 0] },
      '2:1:1:1:2:1': { orderedDimIndexes: [2, 1, 1, 1, 2, 1] },
      '2:1:1:1:2:2': { orderedDimIndexes: [2, 1, 1, 1, 2, 2] },
      '2:1:1:2:0:0': { orderedDimIndexes: [2, 1, 1, 2, 0, 0] },
      '2:1:1:2:0:1': { orderedDimIndexes: [2, 1, 1, 2, 0, 1] },
      '2:1:1:2:0:2': { orderedDimIndexes: [2, 1, 1, 2, 0, 2] },
      '2:1:1:2:1:0': { orderedDimIndexes: [2, 1, 1, 2, 1, 0] },
      '2:1:1:2:1:1': { orderedDimIndexes: [2, 1, 1, 2, 1, 1] },
      '2:1:1:2:1:2': { orderedDimIndexes: [2, 1, 1, 2, 1, 2] },
      '2:1:1:2:2:0': { orderedDimIndexes: [2, 1, 1, 2, 2, 0] },
      '2:1:1:2:2:1': { orderedDimIndexes: [2, 1, 1, 2, 2, 1] },
      '2:1:1:2:2:2': { orderedDimIndexes: [2, 1, 1, 2, 2, 2] },
      '2:1:2:0:0:0': { orderedDimIndexes: [2, 1, 2, 0, 0, 0] },
      '2:1:2:0:0:1': { orderedDimIndexes: [2, 1, 2, 0, 0, 1] },
      '2:1:2:0:0:2': { orderedDimIndexes: [2, 1, 2, 0, 0, 2] },
      '2:1:2:0:1:0': { orderedDimIndexes: [2, 1, 2, 0, 1, 0] },
      '2:1:2:0:1:1': { orderedDimIndexes: [2, 1, 2, 0, 1, 1] },
      '2:1:2:0:1:2': { orderedDimIndexes: [2, 1, 2, 0, 1, 2] },
      '2:1:2:0:2:0': { orderedDimIndexes: [2, 1, 2, 0, 2, 0] },
      '2:1:2:0:2:1': { orderedDimIndexes: [2, 1, 2, 0, 2, 1] },
      '2:1:2:0:2:2': { orderedDimIndexes: [2, 1, 2, 0, 2, 2] },
      '2:1:2:1:0:0': { orderedDimIndexes: [2, 1, 2, 1, 0, 0] },
      '2:1:2:1:0:1': { orderedDimIndexes: [2, 1, 2, 1, 0, 1] },
      '2:1:2:1:0:2': { orderedDimIndexes: [2, 1, 2, 1, 0, 2] },
      '2:1:2:1:1:0': { orderedDimIndexes: [2, 1, 2, 1, 1, 0] },
      '2:1:2:1:1:1': { orderedDimIndexes: [2, 1, 2, 1, 1, 1] },
      '2:1:2:1:1:2': { orderedDimIndexes: [2, 1, 2, 1, 1, 2] },
      '2:1:2:1:2:0': { orderedDimIndexes: [2, 1, 2, 1, 2, 0] },
      '2:1:2:1:2:1': { orderedDimIndexes: [2, 1, 2, 1, 2, 1] },
      '2:1:2:1:2:2': { orderedDimIndexes: [2, 1, 2, 1, 2, 2] },
      '2:1:2:2:0:0': { orderedDimIndexes: [2, 1, 2, 2, 0, 0] },
      '2:1:2:2:0:1': { orderedDimIndexes: [2, 1, 2, 2, 0, 1] },
      '2:1:2:2:0:2': { orderedDimIndexes: [2, 1, 2, 2, 0, 2] },
      '2:1:2:2:1:0': { orderedDimIndexes: [2, 1, 2, 2, 1, 0] },
      '2:1:2:2:1:1': { orderedDimIndexes: [2, 1, 2, 2, 1, 1] },
      '2:1:2:2:1:2': { orderedDimIndexes: [2, 1, 2, 2, 1, 2] },
      '2:1:2:2:2:0': { orderedDimIndexes: [2, 1, 2, 2, 2, 0] },
      '2:1:2:2:2:1': { orderedDimIndexes: [2, 1, 2, 2, 2, 1] },
      '2:1:2:2:2:2': { orderedDimIndexes: [2, 1, 2, 2, 2, 2] },
      '2:2:0:0:0:0': { orderedDimIndexes: [2, 2, 0, 0, 0, 0] },
      '2:2:0:0:0:1': { orderedDimIndexes: [2, 2, 0, 0, 0, 1] },
      '2:2:0:0:0:2': { orderedDimIndexes: [2, 2, 0, 0, 0, 2] },
      '2:2:0:0:1:0': { orderedDimIndexes: [2, 2, 0, 0, 1, 0] },
      '2:2:0:0:1:1': { orderedDimIndexes: [2, 2, 0, 0, 1, 1] },
      '2:2:0:0:1:2': { orderedDimIndexes: [2, 2, 0, 0, 1, 2] },
      '2:2:0:0:2:0': { orderedDimIndexes: [2, 2, 0, 0, 2, 0] },
      '2:2:0:0:2:1': { orderedDimIndexes: [2, 2, 0, 0, 2, 1] },
      '2:2:0:0:2:2': { orderedDimIndexes: [2, 2, 0, 0, 2, 2] },
      '2:2:0:1:0:0': { orderedDimIndexes: [2, 2, 0, 1, 0, 0] },
      '2:2:0:1:0:1': { orderedDimIndexes: [2, 2, 0, 1, 0, 1] },
      '2:2:0:1:0:2': { orderedDimIndexes: [2, 2, 0, 1, 0, 2] },
      '2:2:0:1:1:0': { orderedDimIndexes: [2, 2, 0, 1, 1, 0] },
      '2:2:0:1:1:1': { orderedDimIndexes: [2, 2, 0, 1, 1, 1] },
      '2:2:0:1:1:2': { orderedDimIndexes: [2, 2, 0, 1, 1, 2] },
      '2:2:0:1:2:0': { orderedDimIndexes: [2, 2, 0, 1, 2, 0] },
      '2:2:0:1:2:1': { orderedDimIndexes: [2, 2, 0, 1, 2, 1] },
      '2:2:0:1:2:2': { orderedDimIndexes: [2, 2, 0, 1, 2, 2] },
      '2:2:0:2:0:0': { orderedDimIndexes: [2, 2, 0, 2, 0, 0] },
      '2:2:0:2:0:1': { orderedDimIndexes: [2, 2, 0, 2, 0, 1] },
      '2:2:0:2:0:2': { orderedDimIndexes: [2, 2, 0, 2, 0, 2] },
      '2:2:0:2:1:0': { orderedDimIndexes: [2, 2, 0, 2, 1, 0] },
      '2:2:0:2:1:1': { orderedDimIndexes: [2, 2, 0, 2, 1, 1] },
      '2:2:0:2:1:2': { orderedDimIndexes: [2, 2, 0, 2, 1, 2] },
      '2:2:0:2:2:0': { orderedDimIndexes: [2, 2, 0, 2, 2, 0] },
      '2:2:0:2:2:1': { orderedDimIndexes: [2, 2, 0, 2, 2, 1] },
      '2:2:0:2:2:2': { orderedDimIndexes: [2, 2, 0, 2, 2, 2] },
      '2:2:1:0:0:0': { orderedDimIndexes: [2, 2, 1, 0, 0, 0] },
      '2:2:1:0:0:1': { orderedDimIndexes: [2, 2, 1, 0, 0, 1] },
      '2:2:1:0:0:2': { orderedDimIndexes: [2, 2, 1, 0, 0, 2] },
      '2:2:1:0:1:0': { orderedDimIndexes: [2, 2, 1, 0, 1, 0] },
      '2:2:1:0:1:1': { orderedDimIndexes: [2, 2, 1, 0, 1, 1] },
      '2:2:1:0:1:2': { orderedDimIndexes: [2, 2, 1, 0, 1, 2] },
      '2:2:1:0:2:0': { orderedDimIndexes: [2, 2, 1, 0, 2, 0] },
      '2:2:1:0:2:1': { orderedDimIndexes: [2, 2, 1, 0, 2, 1] },
      '2:2:1:0:2:2': { orderedDimIndexes: [2, 2, 1, 0, 2, 2] },
      '2:2:1:1:0:0': { orderedDimIndexes: [2, 2, 1, 1, 0, 0] },
      '2:2:1:1:0:1': { orderedDimIndexes: [2, 2, 1, 1, 0, 1] },
      '2:2:1:1:0:2': { orderedDimIndexes: [2, 2, 1, 1, 0, 2] },
      '2:2:1:1:1:0': { orderedDimIndexes: [2, 2, 1, 1, 1, 0] },
      '2:2:1:1:1:1': { orderedDimIndexes: [2, 2, 1, 1, 1, 1] },
      '2:2:1:1:1:2': { orderedDimIndexes: [2, 2, 1, 1, 1, 2] },
      '2:2:1:1:2:0': { orderedDimIndexes: [2, 2, 1, 1, 2, 0] },
      '2:2:1:1:2:1': { orderedDimIndexes: [2, 2, 1, 1, 2, 1] },
      '2:2:1:1:2:2': { orderedDimIndexes: [2, 2, 1, 1, 2, 2] },
      '2:2:1:2:0:0': { orderedDimIndexes: [2, 2, 1, 2, 0, 0] },
      '2:2:1:2:0:1': { orderedDimIndexes: [2, 2, 1, 2, 0, 1] },
      '2:2:1:2:0:2': { orderedDimIndexes: [2, 2, 1, 2, 0, 2] },
      '2:2:1:2:1:0': { orderedDimIndexes: [2, 2, 1, 2, 1, 0] },
      '2:2:1:2:1:1': { orderedDimIndexes: [2, 2, 1, 2, 1, 1] },
      '2:2:1:2:1:2': { orderedDimIndexes: [2, 2, 1, 2, 1, 2] },
      '2:2:1:2:2:0': { orderedDimIndexes: [2, 2, 1, 2, 2, 0] },
      '2:2:1:2:2:1': { orderedDimIndexes: [2, 2, 1, 2, 2, 1] },
      '2:2:1:2:2:2': { orderedDimIndexes: [2, 2, 1, 2, 2, 2] },
      '2:2:2:0:0:0': { orderedDimIndexes: [2, 2, 2, 0, 0, 0] },
      '2:2:2:0:0:1': { orderedDimIndexes: [2, 2, 2, 0, 0, 1] },
      '2:2:2:0:0:2': { orderedDimIndexes: [2, 2, 2, 0, 0, 2] },
      '2:2:2:0:1:0': { orderedDimIndexes: [2, 2, 2, 0, 1, 0] },
      '2:2:2:0:1:1': { orderedDimIndexes: [2, 2, 2, 0, 1, 1] },
      '2:2:2:0:1:2': { orderedDimIndexes: [2, 2, 2, 0, 1, 2] },
      '2:2:2:0:2:0': { orderedDimIndexes: [2, 2, 2, 0, 2, 0] },
      '2:2:2:0:2:1': { orderedDimIndexes: [2, 2, 2, 0, 2, 1] },
      '2:2:2:0:2:2': { orderedDimIndexes: [2, 2, 2, 0, 2, 2] },
      '2:2:2:1:0:0': { orderedDimIndexes: [2, 2, 2, 1, 0, 0] },
      '2:2:2:1:0:1': { orderedDimIndexes: [2, 2, 2, 1, 0, 1] },
      '2:2:2:1:0:2': { orderedDimIndexes: [2, 2, 2, 1, 0, 2] },
      '2:2:2:1:1:0': { orderedDimIndexes: [2, 2, 2, 1, 1, 0] },
      '2:2:2:1:1:1': { orderedDimIndexes: [2, 2, 2, 1, 1, 1] },
      '2:2:2:1:1:2': { orderedDimIndexes: [2, 2, 2, 1, 1, 2] },
      '2:2:2:1:2:0': { orderedDimIndexes: [2, 2, 2, 1, 2, 0] },
      '2:2:2:1:2:1': { orderedDimIndexes: [2, 2, 2, 1, 2, 1] },
      '2:2:2:1:2:2': { orderedDimIndexes: [2, 2, 2, 1, 2, 2] },
      '2:2:2:2:0:0': { orderedDimIndexes: [2, 2, 2, 2, 0, 0] },
      '2:2:2:2:0:1': { orderedDimIndexes: [2, 2, 2, 2, 0, 1] },
      '2:2:2:2:0:2': { orderedDimIndexes: [2, 2, 2, 2, 0, 2] },
      '2:2:2:2:1:0': { orderedDimIndexes: [2, 2, 2, 2, 1, 0] },
      '2:2:2:2:1:1': { orderedDimIndexes: [2, 2, 2, 2, 1, 1] },
      '2:2:2:2:1:2': { orderedDimIndexes: [2, 2, 2, 2, 1, 2] },
      '2:2:2:2:2:0': { orderedDimIndexes: [2, 2, 2, 2, 2, 0] },
      '2:2:2:2:2:1': { orderedDimIndexes: [2, 2, 2, 2, 2, 1] },
      '2:2:2:2:2:2': { orderedDimIndexes: [2, 2, 2, 2, 2, 2] },
    };

    const expected = {
      header: [[[0, 0]], [[0, 1]], [[0, 2]], [[1, 0]], [[1, 1]], [[1, 2]], [[2, 0]], [[2, 1]], [[2, 2]]],
      sections: [
        [
          [],
          [
            [[0, 0], [0, 0]],
            [[0, 0], [0, 1]],
            [[0, 0], [0, 2]],
            [[0, 0], [1, 0]],
            [[0, 0], [1, 1]],
            [[0, 0], [1, 2]],
            [[0, 0], [2, 0]],
            [[0, 0], [2, 1]],
            [[0, 0], [2, 2]],
            [[0, 1], [0, 0]],
            [[0, 1], [0, 1]],
            [[0, 1], [0, 2]],
            [[0, 1], [1, 0]],
            [[0, 1], [1, 1]],
            [[0, 1], [1, 2]],
            [[0, 1], [2, 0]],
            [[0, 1], [2, 1]],
            [[0, 1], [2, 2]],
            [[0, 2], [0, 0]],
            [[0, 2], [0, 1]],
            [[0, 2], [0, 2]],
            [[0, 2], [1, 0]],
            [[0, 2], [1, 1]],
            [[0, 2], [1, 2]],
            [[0, 2], [2, 0]],
            [[0, 2], [2, 1]],
            [[0, 2], [2, 2]],
            [[1, 0], [0, 0]],
            [[1, 0], [0, 1]],
            [[1, 0], [0, 2]],
            [[1, 0], [1, 0]],
            [[1, 0], [1, 1]],
            [[1, 0], [1, 2]],
            [[1, 0], [2, 0]],
            [[1, 0], [2, 1]],
            [[1, 0], [2, 2]],
            [[1, 1], [0, 0]],
            [[1, 1], [0, 1]],
            [[1, 1], [0, 2]],
            [[1, 1], [1, 0]],
            [[1, 1], [1, 1]],
            [[1, 1], [1, 2]],
            [[1, 1], [2, 0]],
            [[1, 1], [2, 1]],
            [[1, 1], [2, 2]],
            [[1, 2], [0, 0]],
            [[1, 2], [0, 1]],
            [[1, 2], [0, 2]],
            [[1, 2], [1, 0]],
            [[1, 2], [1, 1]],
            [[1, 2], [1, 2]],
            [[1, 2], [2, 0]],
            [[1, 2], [2, 1]],
            [[1, 2], [2, 2]],
            [[2, 0], [0, 0]],
            [[2, 0], [0, 1]],
            [[2, 0], [0, 2]],
            [[2, 0], [1, 0]],
            [[2, 0], [1, 1]],
            [[2, 0], [1, 2]],
            [[2, 0], [2, 0]],
            [[2, 0], [2, 1]],
            [[2, 0], [2, 2]],
            [[2, 1], [0, 0]],
            [[2, 1], [0, 1]],
            [[2, 1], [0, 2]],
            [[2, 1], [1, 0]],
            [[2, 1], [1, 1]],
            [[2, 1], [1, 2]],
            [[2, 1], [2, 0]],
            [[2, 1], [2, 1]],
            [[2, 1], [2, 2]],
            [[2, 2], [0, 0]],
            [[2, 2], [0, 1]],
            [[2, 2], [0, 2]],
            [[2, 2], [1, 0]],
            [[2, 2], [1, 1]],
            [[2, 2], [1, 2]],
            [[2, 2], [2, 0]],
            [[2, 2], [2, 1]],
            [[2, 2], [2, 2]],
          ]
        ]
      ]
    };

    expect(getSortedLayoutIndexes(layout, observations)).to.deep.equal(expected); 
  });
  it('OBS_ATTRIBUTES', () => {
    const layout = {
      header: [{ id: 'd1', __index: 0 }, { id: 'OBS_ATTRIBUTES' }],
      sections: [{ id: 'd2', __index: 1 }],
      rows: [{ id: 'd3', __index: 2 }],
    };

    const observations = {
      '0:0:0:0': { orderedDimIndexes: [0, 0, 0, 0] },
      '0:0:0:1': { orderedDimIndexes: [0, 0, 0, 1] },
      '0:0:1:0': { orderedDimIndexes: [0, 0, 1, 0] },
      '0:0:1:1': { orderedDimIndexes: [0, 0, 1, 1] },
      '0:1:0:0': { orderedDimIndexes: [0, 1, 0, 0] },
      '0:1:0:1': { orderedDimIndexes: [0, 1, 0, 1] },
      '0:1:1:0': { orderedDimIndexes: [0, 1, 1, 0] },
      '0:1:1:1': { orderedDimIndexes: [0, 1, 1, 1] },
      '1:0:0:0': { orderedDimIndexes: [1, 0, 0, 0] },
      '1:0:0:1': { orderedDimIndexes: [1, 0, 0, 1] },
      '1:0:1:0': { orderedDimIndexes: [1, 0, 1, 0] },
      '1:0:1:1': { orderedDimIndexes: [1, 0, 1, 1] },
      '1:1:0:0': { orderedDimIndexes: [1, 1, 0, 0] },
      '1:1:0:1': { orderedDimIndexes: [1, 1, 0, 1] },
      '1:1:1:0': { orderedDimIndexes: [1, 1, 1, 0] },
      '1:1:1:1': { orderedDimIndexes: [1, 1, 1, 1] },
    };

    const layoutIndexes = {
      header: [[0, 0], [0, 1], [1, 0], [1, 1]],
      sections: [
        [[0], [[0], [1]]],
        [[1], [[0], [1]]]
      ]
    };

    expect(getSortedLayoutIndexes(layout, observations)).to.deep.equal(layoutIndexes);
  });
});
